/* program na ovladani vice rele s pouzitim Neopixel RGB led diod WS2812B nebo WS2811
   pri pouziti WS2811 se MUSI ZMENIT HODNOTA NEO_KHZ800 ZA HODNOTU NEO_KHZ400
   zadavani cisla ovladane RGB didy a hodnot je mozny z PC pomoci prevodniku
   USB/COM TTL s CH340 nebo z tabletu. 
   www.mojeelektronika.mzf.cz
   vagnervlastimil@seznam.cz
*/

#include <Adafruit_NeoPixel.h>
Adafruit_NeoPixel LED = Adafruit_NeoPixel(8, 3, NEO_GRB + NEO_KHZ800);  // max pocet LED, pin pro vystup, rezim
#include <SoftwareSerial.h>                            //prihrani knihovny pro komunikaci 
SoftwareSerial BT=SoftwareSerial(10,11);               // RXD=10 TXD=11 KOMUNIKACNI PINY na ARDUINU 
byte dioda,R,G,B;                                      //promenne
 
void setup() {                                         // zacatek hlavni smycky                              
pinMode(3,OUTPUT);                                     // pin pro ovladani RGB LED v pasku
BT.begin(9600);                                        // komunikacni rychlost
LED.begin();                                           // inicializace komunikace s Neopixel
LED.show();                                            // povel pro prenos dat do led
}

void loop(){                                           // hlavni smycka programu
if (BT.available() > 0){                               // nacteni hodnoty pokud je odeslana
dioda = BT.parseInt();                                 // prvni hodnota je poradi LED
R = BT.parseInt();                                     // druha hodnota je cislo pro intensitu jasu cervene diody
G = BT.parseInt();                                     // treti hodnota je cislo pro intensitu jasu zelene diody
B = BT.parseInt();                                     // ctvrta hodnota je cislo pro intensitu jasu modre diody
if (dioda == 1){                                       // pokud je hodnota diody shodna s hodnotou jedna pokracuje se na dalsim radku
for (int i = 0; i < dioda; i++){                       // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu
dioda=0;                                               // do promenne dioda se ulozi hodnota "0"
delay(500);                                            // casova prodleva
}                                                      // konec smycky if dioda 1
if (dioda == 2){                                       // pokud je hodnota diody shodna s hodnotou dve pokracuje se na dalsim radku
for (int i = 1; i < dioda; i++){                       // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu
dioda=0;                                               // do promenne dioda se ulozi hodnota "0"
delay(500);                                            // casova prodleva
}                                                      // konec smycky volby if dioda 2
if (dioda == 3){                                       // pokud je hodnota diody shodna s hodnotou dve pokracuje se na dalsim radku
for (int i = 2; i < dioda; i++){                       // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody                                
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu  
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu
dioda=0;                                               // do promenne dioda se ulozi hodnota "0"
delay(500);                                            // casova prodleva
}                                                      // konec smycky if dioda 3
if (dioda == 4){                                       // pokud je hodnota diody shodna s hodnotou dve pokracuje se na dalsim radku
for (int i = 3; i < dioda; i++){                       // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody                   
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu
dioda=0;                                               // do promenne dioda se ulozi hodnota "0"
delay(500);                                            // casova prodleva
}                                                      // konec smycky if dioda 4 
if (dioda == 5){                                       // pokud je hodnota diody shodna s hodnotou dve pokracuje se na dalsim radku
for (int i = 4; i < dioda; i++){                       // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody               
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu
dioda=0;                                               // do promenne dioda se ulozi hodnota "0"
delay(500);                                            // casova prodleva
}                                                      // konec smycky if dioda 5
if (dioda == 6){                                       // pokud je hodnota diody shodna s hodnotou dve pokracuje se na dalsim radkufor (int i = 5; i < dioda; i++){                       // opakovani pro cely pasek led
for (int i = 5; i < dioda; i++){                       // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody     
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu  
dioda=0;                                               // do promenne dioda se ulozi hodnota "0"
delay(500);                                            // casova prodleva
}                                                      // konec smycky if dioda 6
if (dioda == 7){                                       // pokud je hodnota diody shodna s hodnotou dve pokracuje se na dalsim radku
for (int i = 6; i < dioda; i++){                       // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody     
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu
dioda=0;                                               // do promenne dioda se ulozi hodnota "0"
delay(500);                                            // casova prodleva
}                                                      // knec smycky if dioda 7
if (dioda == 8){                                       // pokud je hodnota diody shodna s hodnotou dve pokracuje se na dalsim radku 
for (int i = 7; i < dioda; i++){                       // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu
dioda=0;                                               // do promenne dioda se ulozi hodnota "0"
delay(500);                                            // casova prodleva
  }                                                    // konec smycky if dioda 8
 }                                                     // konec smycky if avilable
delay(1000);                                           // casova prodleva
}                                                      // konec hlavni smycky
